//+------------------------------------------------------------------+
//|                                            vav_OpenStopOrder.mq4 |
//|                                                              vav |
//|                                                              vav |
//+------------------------------------------------------------------+
#property copyright "vav"
#property link      "vav"
#property version   "1.00"
#property strict
#property script_show_inputs
//--- input parameters
input int      Ident=123;        // 
input string   coment="";        //
input int      PrSk=3;           //
input int      nbars=100;        //N    StopLoss
input double   mTp=2.0;          //  TakeProfit
input double   mSt=1.0;          //  StopLoss
input double   PrDepo=1;         //   %  

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   int      nZn      = Digits;                                          //- 
   double   CenaOp   = NormalizeDouble(WindowPriceOnDropped(),nZn);     // 
   string   SymB     = Symbol();                                        //
   int      Tf       = Period();                                        // 
   int      SrBr     = Hbars(SymB,Tf,nZn,nbars);                        //  N 
   int      spr      = (int)(MarketInfo(SymB, MODE_SPREAD));            //  
   double   Lo       = Lot(SymB,(int)(SrBr*mSt),PrDepo,spr);    // 
   double   minLot   = MarketInfo(SymB, MODE_MINLOT);
   double   Stop,Take;
   int      ti;
   if(Lo<minLot)
   {
      Alert("  ");
   }
   else
   {
      Lo=NormalizeDouble(Lo,2);
      if(CenaOp>Ask)
      {
         Stop=CenaOp-(SrBr*MathPow(10,-nZn)*mSt)-spr*MathPow(10,-nZn);
         Take=CenaOp+(SrBr*MathPow(10,-nZn)*mTp);
         ti=OrderSend(SymB,OP_BUYSTOP,Lo,CenaOp,PrSk,Stop,Take,(string)Tf+coment,Tf,0,clrNONE);
         if(ti!=-1)
         {
            Alert(" ",ti,"BuyStop");
         }
         else
            Alert("  ");
      }
      if(CenaOp<Bid)
      {
         Stop=CenaOp+(SrBr*MathPow(10,-nZn)*mSt)+spr*MathPow(10,-nZn);
         Take=CenaOp-(SrBr*MathPow(10,-nZn)*mTp);
         ti=OrderSend(SymB,OP_SELLSTOP,Lo,CenaOp,PrSk,Stop,Take,(string)Tf+coment,Tf,0,clrNONE);
         if(ti!=-1)
         {
            Alert(" ",ti,"SellStop");
         }
         else
            Alert("  ");
      }
      if(Bid<=CenaOp && CenaOp<=Ask)Alert("  ");
   }
}
//+------------------------------------------------------------------+
//    N 
int Hbars(string Sy,int Tfr,int Zn,int nbr)
{
   double UsrBr=0;
   int ib;
   for(ib=1;ib<=nbr;ib++)
         {
            UsrBr=UsrBr+MathAbs(iHigh(Sy,Tfr,ib)-iLow(Sy,Tfr,ib));
         }

return((int)(UsrBr/nbr*MathPow(10,Zn)));
}
//+------------------------------------------------------------------+
//    
double Lot(string Sym,int Pn,double pD,int sp)
{
   double L=(AccountBalance()/100*pD)/(MarketInfo(Sym, MODE_TICKVALUE)*(Pn+sp));
return(L);
}